SparkFun u-blox Cellular Arduino Library
========================================

<table class="table table-hover table-striped table-bordered">
  <tr align="center">
   <td><a href="https://www.sparkfun.com/products/23618"><img src="https://cdn.sparkfun.com/r/600-600/assets/parts/2/3/9/0/9/CEL-23618-LTE-Stick-LARA-R6-Feature.jpg"></a></td>
   <td><a href="https://www.sparkfun.com/products/18031"><img src="https://cdn.sparkfun.com/r/600-600/assets/parts/1/7/2/6/0/18031-SparkFun_LTE_GNSS_Breakout_-_SARA-R5-01.jpg"></a></td>
   <td><a href="https://www.sparkfun.com/products/18431"><img src="https://cdn.sparkfun.com/r/600-600/assets/parts/1/7/8/5/8/18431-_DEV_MicroMod_LTE_GNSS_Function_Board-_01.jpg"></a></td>
   <td><a href="https://www.sparkfun.com/products/17272"><img src="https://cdn.sparkfun.com/r/600-600/assets/parts/1/6/2/7/9/17272-SparkFun_MicroMod_Asset_Tracker_Carrier_Board-06a.jpg"></a></td>
  </tr>
  <tr align="center">
    <td><a href="https://www.sparkfun.com/products/23618">SparkFun LTE Stick - LARA-R6 (CEL-23618)</a></td>
    <td><a href="https://www.sparkfun.com/products/18031">SparkFun LTE GNSS Breakout - SARA-R5 (GPS-18031)</a></td>
    <td><a href="https://www.sparkfun.com/products/18431">SparkFun LTE GNSS Function Board - SARA-R5 (GPS-18431)</a></td>
    <td><a href="https://www.sparkfun.com/products/17272">SparkFun MicroMod Asset Tracker Carrier Board (DEV-17272)</a></td>
  </tr>
</table>

This Arduino library configures and controls u-blox cellular modules by sending AT Commands over UART. This library works with the [SparkFun LTE Stick - LARA-R6](https://www.sparkfun.com/products/23618) [SparkFun LTE GNSS Breakout - SARA-R5](https://www.sparkfun.com/products/18031), [SparkFun LTE GNSS Function Board - SARA-R5](https://www.sparkfun.com/products/18431), and [SparkFun MicroMod Asset Tracker Carrier Board](https://www.sparkfun.com/products/17272). Most of the examples work for all of these boards but the audio examples only work for the LTE Stick. These audio examples also require extra hardware outlined in the comments at the beginning of the code.

Repository Contents
-------------------

* **/examples** - Example sketches for the library (.ino). Run these from the Arduino IDE.
* **/src** - Source files for the library (.cpp, .h).
* **library.properties** - General library properties for the Arduino package manager.


Documentation
--------------

* **[Installing an Arduino Library Guide](https://learn.sparkfun.com/tutorials/installing-an-arduino-library)** - Basic information on how to install an Arduino library.
* **[Hookup Guide](https://docs.sparkfun.com/SparkFun_LTE_Stick_LARA_R6)** - Basic hookup guide for the SparkFun LTE Stick.
* **[Product Repository](https://github.com/sparkfun/SparkFun_LTE_Stick_LARA_R6)** - Main repository for the LTE Stick (including hardware files)

License Information
-------------------

This product is _**open source**_! 

Please review the LICENSE.md file for license information. 

If you have any questions or concerns on licensing, please contact technical support on our [SparkFun forums](https://forum.sparkfun.com/viewforum.php?f=152).

Distributed as-is; no warranty is given.

- Your friends at SparkFun.

_<COLLABORATION CREDIT>_
